﻿Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.ComponentModel

Public Enum NWMF
  NWMF_UNLOADING = &H1&
  NWMF_USERINITED = &H2&
  NWMF_FIRST_USERINITED = &H4&
  NWMF_OVERRIDEKEY = &H8&
  NWMF_SHOWHELP = &H10&
  NWMF_HTMLDIALOG = &H20&
  NWMF_FROMPROXY = &H40&
End Enum


Public Class WebBrowserEx
  Inherits WebBrowser

  Private cookie As AxHost.ConnectionPointCookie
  Private wevents As WebBrowserExEvents

  'This method will be called to give you a chance to create your own event sink
  Protected Overrides Sub CreateSink()
    'MAKE SURE TO CALL THE BASE or the normal events won't fire
    MyBase.CreateSink()
    wevents = New WebBrowserExEvents(Me)
    cookie = New AxHost.ConnectionPointCookie(Me.ActiveXInstance, wevents, GetType(IWebBrowserEvents2))
  End Sub

  Protected Overrides Sub DetachSink()
    If Not cookie Is Nothing Then
      cookie.Disconnect()
      cookie = Nothing
    End If
    MyBase.DetachSink()
  End Sub

  'This new event will fire when the page is navigating
  Public Delegate Sub NavigatingExEventHandler(ByVal sender As Object, ByVal e As NavigatingExEventArgs)
  Public Event NavigatingEx As NavigatingExEventHandler

  'This event will fire when a new window is about to be opened
  Public Delegate Sub NewWindowExEventHandler(ByVal sender As Object, ByVal e As NewWindowExEventArgs)
  Public Event NewWindowEx As NewWindowExEventHandler

  Protected Friend Sub OnNavigatingEx(ByVal Url As String, ByVal Frame As String, ByVal Postdata As Byte(), ByVal Headers As String, ByRef Cancel As Boolean)
    Dim e As NavigatingExEventArgs = New NavigatingExEventArgs(Url, Frame, Postdata, Headers)
    RaiseEvent NavigatingEx(Me, e)
    Cancel = e.Cancel
  End Sub

  Protected Friend Sub OnNewWindowEx(ByVal Url As String, ByRef Cancel As Boolean, ByVal Flags As NWMF, ByVal UrlContext As String)
    Dim e As NewWindowExEventArgs = New NewWindowExEventArgs(Url, UrlContext, Flags)
    RaiseEvent NewWindowEx(Me, e)
    Cancel = e.Cancel
  End Sub

End Class
